create_clock -period "322.265625 Mhz" -name ref_clk_clk [get_ports ref_clk_clk]
create_clock -period "100 MHz" -name csr_clk [get_ports csr_clk]
create_clock -period "50 MHz" -name debug_clk [get_ports debug_clk]
derive_clock_uncertainty
derive_pll_clocks

set_false_path -from [get_clocks {csr_clk}] -to [get_clocks {debug_clk}]
set_false_path -from [get_clocks {dut_inst|wrapper_inst|baser_inst|xcvr_native_a10_0|g_xcvr_native_insts[0].twentynm_xcvr_native_inst|inst_twentynm_pma|ch[0].inst_twentynm_pma_ch|gen_twentynm_hssi_pma_rx_deser.inst_twentynm_hssi_pma_rx_deser|clkdiv}] -to [get_clocks {debug_clk}]
set_false_path -from [get_clocks {dut_inst|wrapper_inst|baser_inst|xcvr_native_a10_0|g_xcvr_native_insts[0].twentynm_xcvr_native_inst|inst_twentynm_pma|ch[0].inst_twentynm_pma_ch|gen_twentynm_hssi_pma_rx_deser.inst_twentynm_hssi_pma_rx_deser|clkdiv}] -to [get_clocks {debug_clk}]

# false path at adaptor DC FIFO pointer. This is because both clock are not synchronise
set_false_path -from {altera_eth_10g_mac_base_r_low_latency:dut_inst|altera_eth_avalon_st_adapter:dc_fifo_adapter_inst|alt_em10g32_avalon_dc_fifo:rx_312_to_156|in_wr_ptr_gray[*]} -to {altera_eth_10g_mac_base_r_low_latency:dut_inst|altera_eth_avalon_st_adapter:dc_fifo_adapter_inst|alt_em10g32_avalon_dc_fifo:rx_312_to_156|alt_em10g32_dcfifo_synchronizer_bundle:write_crosser|alt_em10g32_std_synchronizer:sync[*].u|din_s1}
set_false_path -from {altera_eth_10g_mac_base_r_low_latency:dut_inst|altera_eth_avalon_st_adapter:dc_fifo_adapter_inst|alt_em10g32_avalon_dc_fifo:rx_312_to_156|out_rd_ptr_gray[*]} -to {altera_eth_10g_mac_base_r_low_latency:dut_inst|altera_eth_avalon_st_adapter:dc_fifo_adapter_inst|alt_em10g32_avalon_dc_fifo:rx_312_to_156|alt_em10g32_dcfifo_synchronizer_bundle:read_crosser|alt_em10g32_std_synchronizer:sync[*].u|din_s1}

# this constraint is need when instantiate altera_eth_avalon_st_adapter
alt_em10g32_constraint_ptr alt_em10g32_avalon_dc_fifo in_wr_ptr_gray din_s1 3ns 2ns
alt_em10g32_constraint_ptr alt_em10g32_avalon_dc_fifo out_rd_ptr_gray din_s1 3ns 2ns
 
